import java.io.*;

public class Casino {
    
    public static void main(String[] args)throws IOException {
    
    	Console c = new Console();	
    	BufferedReader lee = new BufferedReader(new FileReader("casino.txt"));
    	String linea;
    	int totalAlumnos = 0, largoCola = 0, largoColaMax = 0, minutMaximo = 0, minutTotal = 0;
    	Cola cola = new Cola();
    	
    	while( (linea = lee.readLine() ) != null){
    		
    		if(linea.charAt(0) =='L'){
    			cola.push(Integer.parseInt(linea.substring(1,5)));
    			largoCola++;
    			if(largoCola > largoColaMax) largoColaMax = largoCola;
    		}
    		
    		else if(linea.charAt(0) == 'A'){
    			int salida = Integer.parseInt(linea.substring(1,5));
    			int entrada = cola.pop();
    			int delta = restar(salida,entrada);
    			
    			minutTotal+=delta;
    			totalAlumnos++;
    			largoCola--;
    			
    			if(delta > minutMaximo) minutMaximo = delta;
    		}
       	}
       	c.println("Total alumnos atendidos: "+totalAlumnos);
       	c.println("Largo maximo de la cola: "+largoColaMax);
    	c.println("Tiempo de espera promedio: "+minutTotal*1.0/totalAlumnos+" (min)");
    	c.println("Tiempo maximo de espera: "+minutMaximo+" (min)");
    }
    
    static public int restar(int s, int e){
    	//lo que hace restar es restar de acuerdo a los minutos
    	//por lo que transforma las horas a minutos y de ahi resta
    	int s2 = (s/100)*60 + s%100;
    	int e2 = (e/100)*60 + e%100;
    	return s2-e2;
    }
    
    
}

/*
 Cola: First in, First out
 */
class Cola{    
    Nodo primero;
    
    public Cola() {;}
    public Cola(int x) { 
        primero = new Nodo(x,null);
    }
    
    //push agrega el elemento X al final de la cola
    public void push(int x){
        
        //si la lista esta vacia, agrego al principio
        if(primero == null){
            primero = new Nodo(x,null);
            return;
        }
        
        //buscamos el ultimo nodo
        Nodo r = primero;
        while(r.sgte != null) r=r.sgte;
        
        //agregamos al final el NUEVO nodo
        r.sgte = new Nodo(x,null);
        return;
    }
    
    //pop saca el elemento al principio de la cola
     public int pop(){
         int retorno = primero.valor;
         primero = primero.sgte;
         return retorno;
     }
     
     public boolean empty(){
         return primero == null;
     }
}



class Nodo{
    int valor;
    Nodo sgte;
    
    public Nodo(int x, Nodo y){
        valor = x;
        sgte = y;
    }
}
