public class Polaca {
    
      
    public static void main(String[] args) {
        
        Console cons = new Console();
        Pila pila = new Pila();
        cons.print("Ingrese la expresion en notacion polaca: ");
        String expresion = cons.readLine().trim();
        
        while(expresion.length()!=0){
            char c = expresion.charAt(0);
           if(esNumero(c)){
                pila.push(Integer.parseInt(c+""));
            }
            else if(esOperador(c)){
                double op2 = pila.pop();
                double op1 = pila.pop();
                pila.push(evaluar(op1,c,op2));
            }
            else{
                cons.println("Hay un caracter invalido en la sentencia");
                System.exit(0);
            }
            expresion = expresion.substring(1);
        }
        
        cons.println("El resultado de la expresion es: "+pila.pop());
    }

 
    private static double evaluar(double op1, char c, double op2){
        switch(c){
            case '*': return op1*op2;
            case '/': return op1/op2;
            case '+': return op1+op2;
            case '-': return op1-op2;
        }
        return 0;
    }
    private static boolean esOperador(char c){
        String aux = ""+c;
        if(aux.equals("*") || aux.equals("\\") || aux.equals("+") || aux.equals("-") ){
            return true;
        }
        return false;
    }
    private static boolean esNumero(char c){
        switch(c){
            case '0':case '1':case '2':case '3':case '4':
            case '5':case '6':case '7':case '8':case '9':
                return true;
            default:
                return false;
        }
    }
    
}




/*
 Pila: First in, Last out
 */
class Pila{    
    Nodo primero;
    
    public Pila() {;}
    public Pila(double x) { 
        primero = new Nodo(x,null);
    }
       
    //push agrega el elemento X al tope de la pila
    public void push(double x){
        primero = new Nodo(x,primero);
        return;
    }
    
    //pop saca el elemento al tope de la pila
     public double pop(){
         double retorno = primero.valor;
         primero = primero.sgte;
         return retorno;
     }
     
      public boolean empty(){
         return primero == null;
     }

}


class Nodo{
    double valor;
    Nodo sgte;
    
    public Nodo(double x, Nodo y){
        valor = x;
        sgte = y;
    }
}

